import java.util.Comparator;

/* This class implements a comparator for Integers according to which i > j if the kMer whose integer 
 * representation is i has a WMW / avg. binding score lower than the kMer whose integer representation is j.
 * The comparisonMethod flag should be 0 for WMW and 1 for avg. binding score.
 */

class RankCompare implements Comparator<Integer> {
	
	MerObj kMers[];
	int comparison;
	
	public RankCompare(MerObj[] array, int comparisonMethod) {
		super();
		this.kMers = array;
		this.comparison = comparisonMethod;
	}
	
	public int compare(Integer mer1, Integer mer2){
		int m1 = (int)mer1;
		int m2 = (int)mer2;
		if(this.kMers[m1] == null && this.kMers[m2] == null) return 0;
		if(this.kMers[m1] == null) {return(1);} 
		if(this.kMers[m2] == null) {return (-1);} 
		
		float valueM1;
		float valueM2;
		if(this.comparison == 0) {
			valueM1 = this.kMers[m1].getBerger();
			valueM2 = this.kMers[m2].getBerger();
		} else {
			valueM1 = this.kMers[m1].getAvg();
			valueM2 = this.kMers[m2].getAvg();	
		}
		
		if (valueM1 < valueM2) {
			return (1);
		}
		else {
			if (valueM1 > valueM2) {
				return (-1);
			}
		return (0);
		}
	}	
}
